// This may look like C code, but it is really -*- C++ -*-
// 
// Copyright (C) 1988 University of Illinois, Urbana, Illinois
// Copyright (C) 1989 University of Colorado, Boulder, Colorado
// Copyright (C) 1990 University of Colorado, Boulder, Colorado
//
// written by Dirk Grunwald (grunwald@foobar.colorado.edu)
//
#include "AwesimeFifo.h"

#define FIFO_NAME AwesimeFifo
#define FIFO_ITEM AwesimePtr

#include <assert.h>
#include "GenericFifo.cc"

void FIFO_NAME::classPrintOn(ostream& s)
{
    register int i = listHead;
    register int examined = 0;
    
    s << "[" << GENERIC2(FIFO_NAME,Name) << "]: ";
    if (listElements == 0) {
	s << "(empty)";
    } else {
	s << listElements << " items enqueued:\n";
	while(examined < listElements && i < maxIndex() ) {
	    if (valid(i)) {
		Awesime *something = list[i];
		s << *something;
		examined++;
	    }
	    i = advance(i);
	}
    }
}
